#include <FragmentedMessage.h>

#include<SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
#include <RF24_config.h>

#include <stdio.h>
#include <stdlib.h>

#include <DHT.h>

#include <Wire.h>
#include <Adafruit_MPL115A2.h>

#include<SensorBase.h>
#include<DHTTemperatureSensor.h>
#include<MPL115A2BarometricPressureSensor.h>


const int RF24_CE = 9;
const int RF24_CSN = 10;
RF24 radio(RF24_CE, RF24_CSN);

const int intervalSleepTime = 5000;

////Downstairs Unit
//const uint64_t WRITE_PIPE = 0x0000000000LL;
//const int NUM_SENSORS = 5;
//SensorBase* sensors[NUM_SENSORS] =
//{
//  new DHTTemperatureSensor(2, "Kitchen", &radio, 0x00),
//  new DHTTemperatureSensor(3, "LivingRoom", &radio, 0x00),
//  new DHTTemperatureSensor(4, "LowerSunChamber", &radio, 0x00),
//  new DHTTemperatureSensor(5, "DiningRoom", &radio, 0x00),
//  new MPL115A2BarometricPressureSensor("Downstairs", &radio, 0x00)
//};

////Upstairs Hallway Unit
//const uint64_t WRITE_PIPE = 0x0000000001LL;
//const int NUM_SENSORS = 4;
//SensorBase* sensors[NUM_SENSORS] =
//{
//  new DHTTemperatureSensor(2, "GameRoom", &radio, 0x01),
//  new DHTTemperatureSensor(3, "SunChamber", &radio, 0x01),
//  new DHTTemperatureSensor(4, "ComputerRoom", &radio, 0x01),
//  new DHTTemperatureSensor(5, "MasterBath", &radio, 0x01)
//};

//Backyard Unit
const uint64_t WRITE_PIPE = 0x0000000002LL;
const int NUM_SENSORS = 1;
SensorBase* sensors[NUM_SENSORS] =
{
  new DHTTemperatureSensor(2, "Outside.Backyard", &radio, 0x02)
};





void setup()
{
  Serial.begin(57600);
  initSensors();  
  initRadio();
}

void initSensors()
{
  for(int sensorIndex = 0; sensorIndex < NUM_SENSORS; sensorIndex++)
  {
    Serial.print("Init: ");
    Serial.println(sensorIndex);
    sensors[sensorIndex]->Init();
  }
}

void initRadio()
{
  Serial.println("Init Radio");
  radio.begin();
  radio.setRetries(15,15);
  radio.openWritingPipe(WRITE_PIPE);
}

void loop()
{
  readSensors();  
  delay(intervalSleepTime);
}

void readSensors()
{
    for(int sensorIndex = 0; sensorIndex < NUM_SENSORS; sensorIndex++)
  {
     Serial.print("Read: ");
     Serial.println(sensorIndex);
     sensors[sensorIndex]->Read();
  }
}
