#include "Arduino.h"
#include "DHTTemperatureSensor.h"

DHTTemperatureSensor::DHTTemperatureSensor(int sensorPin, char* location, RF24* radio, int senderID) : SensorBase(location, radio, senderID)
{
  dht = new DHT(sensorPin, DHT22);
}

void DHTTemperatureSensor::Init()
{
  dht->begin();
}

void DHTTemperatureSensor::Read()
{
  float dhtTemperature = dht->readTemperature();
  float dhtHumidity = dht->readHumidity(); 
  
  Serial.print("Probe: ");
  Serial.print(Location);
  Serial.print(" Temp (C): ");
  Serial.print(dhtTemperature);
  Serial.print(" Humidity: ");
  Serial.println(dhtHumidity);

  sendMetric("Gauge", "Temperature", Location, dhtTemperature);
  sendMetric("Gauge", "Humidity", Location, dhtHumidity);
}