#include "Arduino.h"
#include "MPL115A2BarometricPressureSensor.h"

MPL115A2BarometricPressureSensor::MPL115A2BarometricPressureSensor(char* location, RF24* radio, int senderID) : SensorBase(location, radio, senderID)
{
  mpl115a2 = new Adafruit_MPL115A2();
}

void MPL115A2BarometricPressureSensor::Init()
{
  mpl115a2->begin();
}

void MPL115A2BarometricPressureSensor::Read()
{
  float mplPressure = mpl115a2->getPressure(); 
  
  Serial.print("Probe: ");
  Serial.print(Location);
  Serial.print(" Pressure (kPa): ");
  Serial.print(mplPressure);

  sendMetric("Gauge", "Pressure", Location, mplPressure );
}