#ifndef __SensorBase_H__
#define __SensorBase_H__

#include "Arduino.h"
#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
#include <RF24_config.h>
#include <stdio.h>
#include <stdlib.h>
#include <FragmentedMessage.h>

const int NRF_PACKET_SIZE = 32;
const int MAX_METRIC_STRING_SIZE = 255;

class SensorBase
{
  public:
    SensorBase(char* location, RF24* radio, int SenderID);

    char* Location;
    int SenderID;
    virtual void Init() = 0;
    virtual void Read() = 0;

  protected:
    RF24* Radio; 

    void formatMetric(char* buffer, int bufferSize, char* metricType, char* metricPrefix, char* metricName, float value);
    void sendMetric(char* metricType, char* metricPrefix, char* metricName, float value);
};

#endif
